"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* istanbul ignore file */
/* eslint-disable */
const stream = __importStar(require("stream"));
// @ts-ignore
const slip_1 = __importDefault(require("slip"));
const debug_1 = __importDefault(require("debug"));
const debug = debug_1.default('zigbee-herdsman:deconz:driver:parser');
class Parser extends stream.Transform {
    constructor() {
        super();
        this.onMessage = this.onMessage.bind(this);
        this.onError = this.onError.bind(this);
        this.decoder = new slip_1.default.Decoder({
            onMessage: this.onMessage,
            maxMessageSize: 1000000,
            bufferSize: 2048
        });
    }
    onMessage(message) {
        //debug(`message received: ${message}`);
        this.emit('parsed', message);
    }
    onError(_, error) {
        debug(`<-- error '${error}'`);
    }
    _transform(chunk, _, cb) {
        //debug(`<-- [${chunk.toJSON().data}]`);
        this.decoder.decode(chunk);
        //debug(`<-- [${chunk.toJSON().data}]`);
        cb();
    }
}
exports.default = Parser;
//# sourceMappingURL=parser.js.map