"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ts = require("typescript");
const index_1 = require("../../models/index");
const index_2 = require("../factories/index");
const components_1 = require("../components");
const convert_expression_1 = require("../convert-expression");
let PropertyConverter = class PropertyConverter extends components_1.ConverterNodeComponent {
    constructor() {
        super(...arguments);
        this.supports = [
            ts.SyntaxKind.PropertySignature,
            ts.SyntaxKind.PropertyDeclaration
        ];
    }
    convert(context, node) {
        console.log('Property with name', node.name.getText());
        const property = index_2.createDeclaration(context, node, index_1.ReflectionKind.Property, node.name.getText());
        context.withScope(property, () => {
            if (node.initializer) {
                property.defaultValue = convert_expression_1.convertDefaultValue(node.initializer);
            }
            property.type = this.owner.convertType(context, node.type);
        });
        return property;
    }
};
PropertyConverter = __decorate([
    components_1.Component({ name: 'node:property' })
], PropertyConverter);
exports.PropertyConverter = PropertyConverter;
//# sourceMappingURL=property.js.map